<!--
    Original overlay code and implementation by SimpleAOB
    Contact:
        Discord - SimpleAOB#9999 (preferred)
        Email - simple(@at)bakkesplugins(dot)com
    Credits:
        Default images and guidance on art by RJsaraus - https://twitter.com/deeposaurus
-->

<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>Covert - SOS - Rocket League Browser Source Overlay Control board</title>
    <style>
        ${require('../out/css/main.min.css')}
    </style>
    <style>${require('vendor/bootstrap-4.4.1/bootstrap.min.css')}</style>
</head>
<body>
    <div class="loader-overlay hidden">
        <div class="loader-text">
            <div class="spinner-border text-light" role="status">
                <span class="sr-only">Loading...</span>
            </div>
            Waiting for <span class="loader-number-left">1</span> process(es) to finish
        </div>
    </div>
    <div class="page-container">
        <div class="control-dashboard">
            <div class="container-fluid">
                <div class="row">
                    <div class="col h4 text-center">Covert - Stream Control Board</div>
                </div>
                <div class="row">
                    <div class="col">
<!--                        <div class="websocket-status-rl alert alert-secondary opacity-percent-50">Rocket League waiting to connect...</div>-->
                        <div class="websocket-status-rl alert alert-secondary opacity-percent-50">Rocket League now connects through the WS Overlay Relay  ---></div>
                    </div>
                    <div class="col">
                        <div class="websocket-status-overlay alert alert-secondary pointer">Overlay waiting to connect...</div>
                    </div>
                </div>
                <div class="row">
                    <div class="col">
                        <ul class="nav nav-tabs" id="tabPillContainer" role="tablist"></ul>
                        <div class="tab-content" id="tabContentContainer"></div>
                    </div>
                </div>
                <div class="row">
                    <div class="col">
                        <button class="btn btn-secondary" id="componentVersionsModalBtn">View Connected Components</button>
                    </div>
                </div>
            </div>
        </div>
    </div>
    <div aria-live="polite" aria-atomic="true" style="min-height: 200px; position: fixed; top: 20px; right: 20px;">
        <div class="toast-insert-container"></div>
    </div>
    <div id="connectedComponentsModal" class="modal fade" tabindex="-1" role="dialog" aria-labelledby="myExtraLargeModalLabel" aria-hidden="true">
        <div class="modal-dialog" role="document">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title">Connected Components</h5>
                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                </div>
                <div class="modal-body unselectable">
                    <table class="table table-striped">
                        <tr>
                            <th>Name</th>
                            <th>Version</th>
                        </tr>
                        <tr rv-each-component="components">
                            <td>{ component.name }</td>
                            <td>{ component.version }</td>
                        </tr>
                    </table>
                </div>
            </div>
        </div>
    </div>
    <div id="tickerFormattingHelpModal" class="modal fade" tabindex="-1" role="dialog" aria-labelledby="myExtraLargeModalLabel" aria-hidden="true">
        <div class="modal-dialog modal-xl" role="document">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title">Ticker Formatting Help</h5>
                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                </div>
                <div class="modal-body unselectable">
                    <p>
                        There is a very small set of available formatters:
                    </p>
                    <ul>
                        <li>
                            Hashmark: <code>##text goes here##</code>
                            <ul>
                                <li>Wrap your text in hashmarks to apply special header formatting</li>
                            </ul>
                        </li>
                        <li>
                            Underscore: <code>__text goes here__</code>
                            <ul>
                                <li>Wrap your text in underscores to italicise it</li>
                            </ul>
                        </li>
                        <li>
                            Asterisk: <code>**text goes here**</code>
                            <ul>
                                <li>Wrap your text in asterisks to make it bold</li>
                            </ul>
                        </li>
                    </ul>
                    <p>
                        Only the strings listed here are available in the ticker template since the context is regenerated for each team.
                    </p>
                    <pre id="tickerTemplateStringsPre"></pre>
                </div>
            </div>
        </div>
    </div>
    <script>${require('vendor/jquery-3.4.1/jquery-3.4.1.min.js')}</script>
    <script>${require('vendor/bootstrap-4.4.1/bootstrap.min.js')}</script>
    <script>${require('vendor/lodash-4.17.15/lodash.min.js')}</script>
    <script>${require('../node_modules/tinybind/dist/tinybind.min.js')}</script>
    <script>
        /**
         * Lodash settings
         */
        _.templateSettings.interpolate = /{{([\s\S]+?)}}/g;
        let templateCtx = {};
    </script>
    <script>${require('../out/js/base.js')}</script>
    <script>${require('sos-plugins/control-dashboard/js/form-data.js')}</script>
    <script>${require('sos-plugins/control-dashboard/js/loader.js')}</script>
    <script>${require('sos-plugins/control-dashboard/js/modal-controller.js')}</script>
    <script>${require('sos-plugins/control-dashboard/js/toast-controller.js')}</script>
    <script>${require('sos-plugins/control-dashboard/js/tabs-controller.js')}</script>
    <script>
        //!!! Register the websocket listeners before attempting to connect
        WsRocketLeague.subscribe("ws", "open", function() {
            $(".websocket-status-rl")
                .text("Rocket League connected")
                .removeClass("alert-secondary")
                .addClass('alert-success');
        });

        WsRocketLeague.subscribe("ws", "error", function() {
            $(".websocket-status-rl")
                .text("Rocket League websocket error occurred")
                .removeClass("alert-secondary")
                .removeClass("alert-success")
                .addClass('alert-danger');
        });

        WsRocketLeague.subscribe("ws", "close", function() {
            $(".websocket-status-rl")
                .text("Rocket League disconnected")
                .removeClass("alert-secondary")
                .removeClass("alert-success")
                .addClass('alert-danger');
        });

        WsOverlayServer.subscribe("ws", "open", function() {
            $(".websocket-status-overlay")
                .text("Connected to relay. Waiting for overlay acknowledgement")
                .removeClass("alert-secondary")
                .addClass('alert-warning');
        });

        WsOverlayServer.subscribe("ws", "error", function() {
            $(".websocket-status-overlay")
                .text("Overlay websocket error occurred")
                .removeClass("alert-secondary")
                .removeClass("alert-success")
                .addClass('alert-danger');
        });

        WsOverlayServer.subscribe("ws", "close", function() {
            $(".websocket-status-overlay")
                .text("Overlay connection closed, unknown reason")
                .removeClass("alert-secondary")
                .removeClass("alert-success")
                .addClass('alert-danger');
        });

        let wsHasConnectedOnce = false;
        let lastHeartBeat = 0;
        let heartBeatsMissed = 0;
        WsOverlayServer.subscribe("cb", "ack", function () {
            wsHasConnectedOnce = true;
            lastHeartBeat = Math.floor(+ new Date()/1000);

            $(".websocket-status-overlay")
                .text("Overlay connected")
                .removeClass("alert-warning")
                .addClass('alert-success');
        });
        WsOverlayServer.subscribe("cb", "heartbeat", function () {
            heartBeatsMissed = 0;
            lastHeartBeat = Math.floor(+ new Date()/1000);
        });

        // Overlay heartbeat
        setInterval(function () {
            if (wsHasConnectedOnce) {
                let tnow = Math.floor(+ new Date()/1000);
                if ((tnow - lastHeartBeat) > 1) {
                    heartBeatsMissed++;
                    $(".websocket-status-overlay")
                        .text(`Overlay connected - Possible service interruption (MHB ${heartBeatsMissed})`)
                }
            }
        }, 1500);

        function initRlWsServer() {
            ModalController.show({
                title: "Connect to Websocket Server (Rocket League)",
                message: "What \"host:port\" is it on? If everything is running on 1 computer, use the default settings",
                size: ModalController.sizes.Large,
                type: ModalController.types.TextInput,
                inputDefault: "localhost:49122"
            }).then((d) => {
                let parts = d.split(':');
                $(".websocket-status-rl")
                    .text('Rocket League waiting to connect...')
                    .attr('class', 'websocket-status-rl alert alert-secondary pointer');
                WsRocketLeague.init(parts[0], parts[1], true);
            });
        }

        function initOverlayWsServer() {
            ModalController.show({
                title: "Connect to Websocket Server (Overlays)",
                message: "What \"host:port\" is it on? If everything is running on 1 computer, use the default settings",
                size: ModalController.sizes.Large,
                type: ModalController.types.TextInput,
                inputDefault: "localhost:49322"
            }).then((d) => {
                let parts = d.split(':');
                $(".websocket-status-overlay")
                    .text('Overlay waiting to connect...')
                    .attr('class', 'websocket-status-overlay alert alert-secondary pointer');
                WsOverlayServer.init(parts[0], parts[1], false, [
                    'cb:heartbeat',
                    'game:update_state'
                ]);
            });
        }
    </script>
    <script>
        $(function () {
            // initRlWsServer();
            initOverlayWsServer();
            ToastController.startPurgeInterval();
        });
        $(".websocket-status-rl").click(function () {
            // initRlWsServer();
        });
        $(".websocket-status-overlay").click(function () {
            initOverlayWsServer();
        });
        $(".btn.ticker-formatting-help").click(function () {
            let preLines = [
                "wpercent","w","l","streak","form","sw","sl","gamesplayed","f","a","gb","gd","pts","name","pos","prefab_record","prefab_tie_pos",
            ];
            $('#tickerTemplateStringsPre').text(preLines.join('\n'));
            $("#tickerFormattingHelpModal").modal('show');
        });
        $('#templateStringsModalBtn').click(function () {
            let temp = [];
            let longest = 0;

            _.each(templateCtx, function (v, k) {
                if (k.length > longest) {
                    longest = k.length;
                }
                temp.push({'name': k, 'value': v});
            });
            temp = _.sortBy(temp, 'name');
            let formatted = temp.length + " string(s) available\n";
            formatted += _.padEnd('', longest, '-') + "\n\n";

            _.each(temp, function (o) {
                let template = _.template("{{name}} = '{{value}}'\n");
                formatted += template({
                    'name': _.padEnd(o['name'], longest),
                    'value': o['value']
                });
            });
            ModalController.show("Template Strings", `<pre>${formatted}</pre>`, ModalController.sizes.Large);
        });
    </script>
    <script>
        $('#tabPillContainer a').on('click', function (e) {
            e.preventDefault();
        })
    </script>
    <script>
        let componentProxy = {
            'ControlBoard': {
                name: 'ControlBoard (self)',
                version: ${require('../version.txt')}
            }
        };
        const connectedComponentBinds = {
            components: [],
        };
        $(function () {
            tinybind.bind($("#connectedComponentsModal"), connectedComponentBinds);
            connectedComponentBinds.components = Object.values(componentProxy);
        });

        WsOverlayServer.subscribe("cb", "first_connect", function (d) {
            componentProxy[d['name']] = d;
            connectedComponentBinds.components = Object.values(componentProxy);
        });

        $("#componentVersionsModalBtn").click(function () {
            $("#connectedComponentsModal").modal('show');
        });
    </script>
    <script>${require('sos-plugins/testing/js/testing.js')}</script>
</body>
</html>